package com.loafle.overflow.model.meta;

import javax.persistence.*;
import java.util.Date;

/**
 * Created by root on 17. 6. 22.
 */
@Entity
@Table(name = "META_INFRA_VENDOR", schema = "public")
public class MetaInfraVendor {
  private Integer id;
  private String name;
  private Date createDate;
  private MetaInfraType metaInfraType;

  @Id
  public Integer getId() {
    return id;
  }

  public void setId(Integer id) {
    this.id = id;
  }

  @Column(name = "NAME", nullable = true, length = 50)
  public String getName() {
    return name;
  }

  public void setName(String name) {
    this.name = name;
  }

  @Temporal(TemporalType.TIMESTAMP)
  @Column(name = "CREATE_DATE", nullable = false, columnDefinition = "TIMESTAMP DEFAULT CURRENT_TIMESTAMP", insertable = false, updatable = false)
  public Date getCreateDate() {
    return createDate;
  }

  public void setCreateDate(Date createDate) {
    this.createDate = createDate;
  }

  @ManyToOne
  @JoinColumn(name = "META_INFRA_TYPE_ID", nullable = false)
  public MetaInfraType getMetaInfraType() {
    return metaInfraType;
  }

  public void setMetaInfraType(MetaInfraType metaInfraType) {
    this.metaInfraType = metaInfraType;
  }

  public static MetaInfraVendor CreateInfraVendorByOS(String osName) {

    MetaInfraVendor vendor = new MetaInfraVendor();

    if (osName == null || osName.length() <= 0) {
      vendor.setId(24); // FIXME: Unknown
      return vendor;
    }

    if (osName.equals("Windows")) {
      vendor.setId(26);
    } else if (osName.equals("Linux")) {
      vendor.setId(28); // ubuntu
    } else {
      vendor.setId(24); // FIXME: Unknown
    }

    return vendor;
  }

  public static MetaInfraVendor CreateInfraVendorByPort(int portNumber) {
    return null;
  }

  public static MetaInfraVendor CreateInfraVendorByService(String serviceName) {

    MetaInfraVendor vendor = new MetaInfraVendor();

    if (serviceName.equals("mysql")) {
      vendor.setId(11);
    } else if (serviceName.equals("portgresql")) {
      vendor.setId(15);
    } else if (serviceName.equals("wmi")) {
      vendor.setId(23);
    } else if (serviceName.equals("snmpv2")) {
      vendor.setId(20);
    } else {
      vendor.setId(24); // unknown
    }

    return vendor;
  }
}
